#include "main.h"

void Hiscore::load(const char *file)
	{
	char *tmp;
	int length;
	Parser wyniki;
	ifstream in(file);
	if(!in.is_open())
		{
		printf("FAIL: Hiscore.load: Nie udalo sie otworzyc pliku\n");
		return;
		}
	in.seekg(0, ios::end);
	length=in.tellg();
	in.seekg(0, ios::beg);
	clear();
	try
		{
		tmp=new char[length+1];
		}
	catch(bad_alloc &)
		{
		printf("FAIL: Hiscore.load: Nie udalo sie zajac pamieci na plik tymczasowy\n");
		return;
		}
	in.read(tmp, length);
	tmp[length]='\0';
	wyniki=tmp;
	delete [] tmp;
	if(wyniki.count()<=0 || wyniki.count()%3!=0)
		{
		printf("FAIL: Hiscore.load: Zly plik (%d)\n", wyniki.count());
		return;
		}
	try
		{
		db=new Hiscore::Entry[wyniki.count()/3];
		}
	catch(bad_alloc &)
		{
		printf("FAIL: Hiscore.load: Nie udalo sie zajac pamieci na tabele\n");
		return;
		}
	entries=wyniki.count()/3;
	for(int i=0; i<entries; i++)
		{
		try
			{
			db[i].nick=new char[min((int)wyniki[i*3].length(), 32)+1];
			}
		catch(bad_alloc &)
			{
			printf("FAIL: Hiscore.load: Nie udalo sie zajac pamieci na nick gracza\n");
			return;
			}
		memcpy(db[i].nick, wyniki[i*3].c_str(), min((int)wyniki[i*3].length(), 32));// Wpisywanie nicku
		db[i].nick[min((int)wyniki[i*3].length(), 32)]='\0';
		db[i].id=i+1;
		db[i].kills=wyniki.val(i*3+1);				// ...ilosci zabojstw...
		db[i].time=wyniki.val(i*3+2);				// ...oraz czasu.
		//printf("INFO: Hiscore.load: |%s| |%d| |%d|\n", db[i].nick, db[i].kills, db[i].time);
		}
	//sortKill();
	printf("OK  : Hiscore.load: Wczytano wyniki\n");
	}

void Hiscore::clear()
	{
	if(db!=NULL)
		{
		for(int i=0; i<entries; i++)
			delete [] db[i].nick;
		delete [] db;
		}
	/*if(table!=NULL)
		{
		for(int row=0; row<rows; row++)
			delete [] table[row];
		delete [] table;
		}*/
	}

void Hiscore::sortKill()
	{
	//printf("Sortowanie...\n");
	qsort((void *)db, entries, sizeof(Entry), qcompKill);
	type=1;
	}

void Hiscore::sortTime()
	{
	qsort((void *)db, entries, sizeof(Entry), qcompTime);
	type=0;
	}

int Hiscore::qcompKill(const void *itm1, const void *itm2)
	{
	//printf("comp...\n");
	Entry *e1=(Entry *)itm1;
	Entry *e2=(Entry *)itm2;
	if(e1->kills>e2->kills)
		return -1;
	else if(e1->kills<e2->kills)
		return 1;
	else
		return 0;
	}

int Hiscore::qcompTime(const void *itm1, const void *itm2)
	{
	Entry *e1=(Entry *)itm1;
	Entry *e2=(Entry *)itm2;
	if(e1->time>e2->time)
		return -1;
	else if(e1->time<e2->time)
		return 1;
	else
		return 0;
	}
