class WeaponDrop: public Particle
	{
	public:
		WeaponDrop(Sprite *setSprite, int setX, int setY, vect &setGrav, vect &setRes, float setAng, float setForce, int setLife, int type, int timer=30):
			Particle(setSprite, setX, setY, setGrav, setRes, setAng, setForce, setLife), type(type), timer(timer) {};
		//WeaponDrop(WeaponDrop &src):
		//	Particle(src), type(src.type) {};

		const int type;
		int timer;

		//bool getCol();
	};

class Weapon: public Object
	{
	protected:
		bool done;
		int time;
	public:
		Weapon(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, int time, bool ignoreSprite=0):
			Object(setid, setx, sety, setsprite, setGrav,  setRes, ignoreSprite), done(0), time(time) {};
		~Weapon();

		inline bool getDone() {return done;}

		//virtual void move();
	};

// Eisen! Cartridge load!
class Explosion: public Weapon								/// Pamietaj o dodaniu ignorowania braku sprite
	{
	private:
		int power;
	public:
		Explosion(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, int power=10):
			Weapon(setid, setx, sety, setsprite, setGrav,  setRes, 32), power(power) {if(power>0) PlaySound("explosion00.wav");};

		void move();
	};

class Bomb: public Weapon
	{
	public:
		Bomb(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes):
			Weapon(setid, setx, sety, setsprite, setGrav,  setRes, 126) {};

		void move();
	};

class Flame: public Weapon
	{
	public:
		Flame(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, int time):
			Weapon(setid, setx, sety, setsprite, setGrav,  setRes, time, 1) {PlaySound("flame.wav");};

		void move();
	};

class Airstrike: public Weapon
	{
	private:
		int count;
		int tgx, tgy;
	public:
		Airstrike(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, int count=0):
			Weapon(setid, setx+96, -48, setsprite, setGrav,  setRes, 0), count(count), tgx(setx), tgy(sety) {vectors.y=5;};

		void move();
	};

class Armageddon: public Weapon
	{
	private:
		int count;
		int tgx, tgy;
	public:
		Armageddon(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, int count=0):
			Weapon(setid, setx+sety+32, -32, setsprite, setGrav,  setRes, 0), count(count), tgx(setx), tgy(sety) {vectors.y=8; if(rand()%3==1) PlaySound("fireball.wav");};

		void move();
	};

class Concrete: public Weapon
	{
	public:
		Concrete(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes):
			Weapon(setid, setx, -64, setsprite, setGrav,  setRes, 0) {sety++;};

		void move();
	};

class Muchozol: public Weapon
	{
	private:
		int count;
	public:
		Muchozol(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, int time=0, int count=0):
			Weapon(setid, setx, sety, setsprite, setGrav,  setRes, time, 1), count(count) {};

		void move();
	};
